api/views/validation.py
#   datamax/api/views/validation.py
#   Copyright (C) 2019 Axtria.
#
#   Author: Varun Singhal <varun.singhal@axtria.com>
from flask import render_template, Blueprint

views_validation = Blueprint('views_validation', __name__)


@views_validation.route('login')
def login():
    return render_template('validation/login.html')


@views_validation.route('index')
def index():
    """List of all the files"""
    return render_template('validation/index.html')


@views_validation.route('add_s3')
def file_add_s3():
    return render_template('validation/add_s3.html')


@views_validation.route('add_redshift')
def file_add_redshift():
    return render_template('validation/add_redshift.html')


@views_validation.route('list_config')
def list_config():
    return render_template('validation/list_config.html')


@views_validation.route('/add')
def add_config():
    return render_template('validation/add_config.html')


@views_validation.route('/edit')
def edit_config():
    return render_template('validation/edit_config.html')


@views_validation.route('/list_config_instance')
def list_config_instance():
    return render_template('validation/list_config_instance.html')

api/templates/validation/add_redshift.html
{# _datamax/api/templates/files/add_redshift.html_ #}
{% extends "validation_layout.html" %}

{% block body %}
<div class="row">
    <div class="col-md-8">
        <h5 class="card-title">Add Redshift table</h5>
    </div>
    <div class="col-md-4 text-right">

    </div>
</div>
<br/>
<form method="post" action="{{ url_for('api_exchange.index') }}" id="addRedshiftTableform">
    <input type="hidden" name="name" value="register_file_for_validation"/>
    <input type="hidden" name="source_type" value="rs"/>
    <input type="hidden" name="properties" id="properties"/>
    <input type="hidden" name="shape" id="shape" />
    <div class="form-group">
        <label for="project">Project</label>
        <select class="form-control" id="project" name="project">
            <option disabled selected value></option>
        </select>
        <small id="projectHelp" class="form-text text-muted">
        </small>
    </div>
    <div class="form-group">
        <label for="connector">Connector</label>
        <select class="form-control" id="connector" name="connector_id">
            <option disabled selected value></option>
        </select>
        <small id="connectorHelp" class="form-text text-muted">
            Connections will be established at run time for the given resource key.
        </small>
    </div>
    <div class="form-group">
        <label for="connector">Registration Name</label>
        <input type="text" class="form-control" id="file_name" placeholder="" name="file_name">
    </div>
    <div class="form-group">
        <label for="description">Description</label>
        <input type="text" class="form-control" id="description" placeholder="" name="description">
    </div>
    <div class="form-group">
        <label for="schema">Schema</label>
        <input type="text" class="form-control" id="schema" placeholder="" name="schema">
    </div>
    <div class="form-group">
        <label for="table_name">Table Name</label>
        <input type="text" class="form-control" id="table_name" placeholder="" name="table_name">
        <small id="objectHelp" class="form-text text-muted">
        </small>
    </div>
    <input type="submit" class="btn btn-primary float-right" name="submit" value="Add">
    <div class="loading float-right"></div>

</form>

<script>
    $("#addRedshiftTableform").submit(function() {
        // build properties
        $("#properties").val(JSON.stringify({
            "schema": $("input[name='schema']").val(),
            "table_name": $("input[name='table_name']").val(),
        }));

        var shapeFormData = "rs_connector_id="+ $("#connector").val() + "&schema=" + $("#schema").val() + "&table_name=" + $("#table_name").val();

        $.get("{{ url_for('operations.get_shape') }}?" + shapeFormData,  function (data) {
            console.log(data);
            $("#shape").val(JSON.stringify(data.shape));

            // submit the form
            $.ajax({
                 type: "GET",
                 url: $("#addRedshiftTableform").attr('action'),
                 data: $("#addRedshiftTableform").serialize(),
                 success: function(data) {
                    console.log(data);
                    window.location.href = "{{ url_for('views_validation.index') }}";
                 }
               }); // .second request ends
       });
       return false;
  });

   $(document).ready(function(){
        $.ajax({
            type:"POST",
            url: "{{ url_for('api_exchange.index') }}?name=all_projects",
            data: {},
            success: function(data) {
                console.log(data);
                $.each(data.Contents, function(index, val){
                    $("#project").append('<option value="' + val.id + '">' + val.name + '</option>');
                });
            }
        });

        $("#project").on( "change", function() {
            var project_id = $(this).val();
            $("#connector").html("<option disabled selected value></option>");
            $.ajax({
                type:"POST",
                url: "{{ url_for('api_exchange.index') }}?name=get_connections&connection_type=rs&project_id=" + project_id,
                data: {},
                success: function(data) {
                    console.log(data);
                    $.each(data.Contents, function(index, val){
                        $("#connector").append('<option value="' + val.id + '">' + val.name + '</option>');
                    });
                }
             });
        });
    });

</script>

{% endblock %}

api/templates/validation/add_s3.html
{# _datamax/api/templates/validation/add_s3.html_ #}
{% extends "validation_layout.html" %}

{% block body %}
<div class="row">
    <div class="col-md-8">
        <h5 class="card-title">Add S3 file</h5>
    </div>
    <div class="col-md-4 text-right">

    </div>
</div>
<br/>
<form method="post" action="{{ url_for('api_exchange.index') }}" id="addS3Fileform">
    <input type="hidden" name="name" value="register_file_for_validation"/>
    <input type="hidden" name="source_type" value="s3"/>
    <input type="hidden" name="properties" id="properties"/>
    <input type="hidden" name="shape" id="shape" />

    <div class="form-group">
        <label for="project">Project</label>
        <select class="form-control" id="project" name="project">
            <option disabled selected value></option>
        </select>
        <small id="projectHelp" class="form-text text-muted">
        </small>
    </div>
    <div class="form-group">
        <label for="connector">Connector</label>
        <select class="form-control" id="connector" name="connector_id">
            <option disabled selected value></option>
        </select>
        <small id="connectorHelp" class="form-text text-muted">
            Connections will be established at run time for the given resource key.
        </small>
    </div>
    <div class="form-group">
        <label for="connector">Registration Name</label>
        <input type="text" class="form-control" id="file_name" placeholder="" name="file_name">
    </div>
    <div class="form-group">
        <label for="description">Description</label>
        <input type="text" class="form-control" id="description" placeholder="" name="description">
    </div>
    <div class="form-group">
        <label for="source_bucket">Source bucket</label>
        <input type="text" class="form-control" id="source_bucket" placeholder="" name="source_bucket">
    </div>
    <div class="form-group">
        <label for="source_object">Source object</label>
        <input type="text" class="form-control" id="source_object" placeholder="" name="source_object">
        <small id="objectHelp" class="form-text text-muted">
            Source object's path should end with slash /.
        </small>
    </div>
    <div class="form-group">
        <label for="header_object">Header object</label>
        <input type="text" class="form-control" id="header_object" placeholder="" name="header_object">
        <small id="headerHelp" class="form-text text-muted">
            Header file should be a complete file path along with file extension.
        </small>
    </div>
    <div class="form-group">
        <label>If data file mentioned in source object has header as first row.</label>
        <br>
        <div class="form-check form-check-inline">
            <input class="form-check-input" type="radio" name="data_header" id="inlineRadio1"
                   value="True">
            <label class="form-check-label" for="inlineRadio1">True</label>
        </div>
        <div class="form-check form-check-inline">
            <input class="form-check-input" type="radio" name="data_header" id="inlineRadio2"
                   value="False" checked>
            <label class="form-check-label" for="inlineRadio2">False</label>
        </div>
    </div>
    <div class="form-group">
        <label for="delimiter">Delimiter</label>
        <input type="text" class="form-control" id="delimiter" placeholder="" name="delimiter">
    </div>
    <div class="form-group">
        <label for="file_format">File format</label>
        <select class="form-control" id="file_format" name="file_format">
            <option value="TEXTFILE">TEXTFILE</option>
            <option value="PARQUET">PARQUET</option>
            <option value="ORC">ORC</option>
            <option value="AVRO">AVRO</option>
            <option value="SEQUENCEFILE">SEQUENCEFILE</option>
        </select>
    </div>
    <input type="submit" class="btn btn-primary float-right" name="submit" value="Add">
    <div class="loading float-right"></div>

</form>

<script>
    $("#addS3Fileform").submit(function() {
        // build properties
        $("#properties").val(JSON.stringify({
            "source_bucket" : $("input[name='source_bucket']").val(),
            "source_object" : $("input[name='source_object']").val(),
            "header_object" : $("input[name='header_object']").val(),
            "delimiter"     : $("input[name='delimiter']").val(),
            "data_header"   : $("input[name='data_header']").val(),
            "file_format"   : $("select[name='file_format']").val(),
        }));

        var shapeFormData = "s3_connector_id="+ $("#connector").val() + "&source_bucket=" + $("#source_bucket").val() + "&header_object=" + $("#header_object").val();
        var shape = [];

        $.get("{{ url_for('operations.read_header') }}?" + shapeFormData,  function (data) {
            console.log(data);
            $("#delimiter").val(data.delimiter);

            $.each(data.header, function(index, val){
                shape.push({"name": val, "dtype": "varchar"});
            });
            $("#shape").val(JSON.stringify(shape));

            // submit the form
            $.ajax({
                 type: "GET",
                 url: $("#addS3Fileform").attr('action'),
                 data: $("#addS3Fileform").serialize(),
                 success: function(data) {
                    console.log(data);
                    window.location.href = "{{ url_for('views_validation.index') }}";
                 }
               }); // .second request ends
       });
       return false;
    });

    $(document).ready(function(){
        // building project names drop-down menu
        $.ajax({
        type:"POST",
        url: "{{ url_for('api_exchange.index') }}?name=all_projects",
        data: {},
        success: function(data) {
            console.log(data);
            $.each(data.Contents, function(index, val){
                $("#project").append('<option value="' + val.id + '">' + val.name + '</option>');
            });
        }
        });

        $("#project").on( "change", function() {
            var project_id = $(this).val();
            $("#connector").html("<option disabled selected value></option>");
            $.ajax({
                type:"POST",
                url: "{{ url_for('api_exchange.index') }}?name=get_connections&connection_type=s3&project_id=" + project_id,
                data: {},
                success: function(data) {
                    console.log(data);
                    $.each(data.Contents, function(index, val){
                        $("#connector").append('<option value="' + val.id + '">' + val.name + '</option>');
                    });
                }
             });
        });
    });



</script>


{% endblock %}

api/templates/validation/index.html
{# _datamax/api/templates/files/index.html_ #}
{% extends "validation_layout.html" %}

{% block body %}
<div class="row">
    <div class="col-md-8">
        <h5 class="card-title">Registered files in the system</h5>
    </div>
    <div class="col-md-4 text-right">

    </div>
</div>
<br/>
<div>
<table id="Content" class="display" style="90%">
<thead>
    <tr>
        <th>Id</th>
        <th>Name</th>
        <th>Description</th>
        <th>Created Date</th>
        <th>Source Type</th>
        <th>Validation Configuration</th>
    </tr>
</thead>
</table>
</div>
<script>
    $(document).ready(function() {
        var table = $('#Content').DataTable({
             "stateSave": true,
             "order": [[ 0, "desc" ]],
             "ajax": {
                url: "{{ url_for('api_exchange.index') }}?name=list_files",
                dataSrc: 'Contents'
             },
             "columns": [
                { data: "id" },
                { data: "name" },
                { data: "description" },
                { data: "creation_date" },
                { data: null },
                { "data": null, "width": "10%" }
             ],
             columnDefs: [{
                // puts a button in the last column
                targets: [-1], render: function (a, b, data, d) {
                    return '&ensp;&ensp;<a href="{{ url_for('views_validation.list_config') }}?file_id=' +
                           data.id + '&source_type=' + data.source_type + '&name=' + data.name + '">' +
                           '<i class="fas fa-cogs"></i></a>&ensp;&ensp;';


                }
            },
            {
                targets: [-2], render: function (a, b, data, d) {
                    if (data.source_type == 's3') {
                        return '<span class="badge badge-info">S3</span>';
                    } else if (data.source_type == 'rs') {
                        return '<span class="badge badge-success">Redshift</span>';
                    }

                }
            }]
             
        });
    });
</script>
{% endblock %}

api/templates/validation/list_config.html
{# _datamax/api/templates/validation/list_config.html_ #}
{% extends "validation_layout.html" %}

{% block body %}
<div class="row">
    <div class="col-md-8">
        <h5 class="card-title">List of validation configurations - {{ request.args.get('name') }} [{{ request.args.get('source_type') }}]</h5>
    </div>
    <div class="col-md-4 text-right">
        <a href="{{ url_for('views_validation.add_config') }}?file_id={{ request.args.get('file_id') }}&name={{ request.args.get('name')}}&source_type={{ request.args.get('source_type') }}">
            <i class="fas fa-plus-square"></i>&ensp;New configuration
        </a>
    </div>
</div>
<br/>
<div>
<table id="Content" class="display" style="90%">
<thead>
    <tr>
        <th>Id</th>
        <th>Version</th>
        <th>Name</th>
        <th>Created Date</th>
        <th>Is Active</th>
        <th>Actions</th>
    </tr>
</thead>
</table>
</div>
<script>
    $(document).ready(function() {
        var file_id = {{ request.args.get('file_id')}};
        var source_type = "{{ request.args.get('source_type') }}";

        var table = $('#Content').DataTable({
             "stateSave": true,
             "order": [[ 0, "desc" ]],
             "ajax": {
                url: "{{ url_for('api_exchange.index') }}?name=list_config&id=" + file_id,
                dataSrc: 'Contents'
             },
             "columns": [
                { data: "id" },
                { data: "version" },
                { data: "name" },
                { data: "creation_date" },
                { data: "is_active" },
                { "data": null, "width": "10%" }
             ],
             columnDefs: [{
                // puts a button in the last column
                targets: [-1], render: function (a, b, data, d) {
                    return '&ensp;&ensp;<a href="{{ url_for('views_validation.edit_config') }}?config_id=' +
                    data.id + '&file_id={{ request.args.get('file_id') }}&name={{ request.args.get('name')}}&source_type={{ request.args.get('source_type') }}"><i class="fas fa-edit"></i></a>' +
                       '&ensp;&ensp;<a href="#">' +
                       '<i class="fas fa-play"></i></a>&ensp;&ensp;' +
                       '<a href="#"><i class="fas fa-list-alt"></i> </a>';

                }
            }]
             
        });
    });
</script>
{% endblock %}

api/templates/validation/login.html
{# _datamax/api/templates/api_exchange/login.html_ #}
{% extends "public_layout.html" %}

{% block body %}
<div class="col-md-4"></div>
<div class="col-md-4">
    <!--- \\\\\\\Post-->
    <div class="card gedf-card" style="margin-top:35%">
        <div class="card-body text-center">
            <form class="form-signin" action="#" id="signInForm">
                <h4 class="h4 mb-4">Validation Engine</h4>
                <label for="inputModuleName" class="sr-only">Module name</label>
                <input type="text" id="inputModuleName" class="form-control" placeholder="Module name"
                       name="module_name" required>
                <br>
                <label for="inputPassword" class="sr-only">Password</label>
                <input type="password" id="inputPassword" class="form-control" placeholder="Password" name="password"
                       required>
                <br>
                <input class="btn btn-primary btn-block" value="Sign in" type="submit">
                <p class="mt-5 mb-3 text-muted">&copy; 2019 Axtria.</p>
            </form>
        </div> <!-- .card body ends-->
    </div>
    <!-- Post /////-->
</div>
<div class="col-md-4"></div>
<script>
    $("#signInForm").submit(function() {
        $.ajax({
         type: "POST",
         url: "{{ url_for('api_exchange.authorize') }}",
         data: $(this).serialize(),
         success: function(data) {
                console.log(data);
                window.location.href = "{{ url_for('views_validation.index') }}";
         }
       })
       return false;
  })
</script>
{% endblock %}